; This function calculates the fundamental array of
; Seidelmann Tab. 3.222.2

 FUNCTION FUNDAMENTAL_FRAC,c
   index=WHERE(ABS(c) GT 2.14748e+09)
   IF  index NE -1 THEN BEGIN
    MESSAGE,'argument too big.',/cont
    RETURN,c*0
   ENDIF
   fracc=c-LONG(c)
 RETURN,fracc
 END

 FUNCTION FUNDAMENTAL,tj

  nel=N_ELEMENTS(tj)

  funarr=DBLARR(nel,5)

  funcoeff=[[134.5746733d,1325.0d,198.5202633d, 31.310d,0.064d], $
            [357.3139804d,99.0d  ,359.0301224d, -0.577d,0.012d], $
            [ 93.1618877d,1342.0d, 82.0103137d,-13.257d,0.011d], $
            [297.5101307d,1236.0d,307.0641328d, -6.891d,0.019d], $
            [125.0240280d,  -5.0d,-134.0810539d,  7.455d,0.008d]]

; corrected value for Omega(0): 135>125

  secperrot=360.0d*3600.0d

  FOR i=0l,nel-1l DO BEGIN
    ti=tj(i)
    funarr(i,*)=DEGSEC(funcoeff(0,*))+FUNDAMENTAL_FRAC(funcoeff(1,*)*ti)*secperrot + $
        ti*(DEGSEC(funcoeff(2,*))+ti*(funcoeff(3,*)+ti*funcoeff(4,*))) 
  ENDFOR
  funarr=funarr/3600.0d

 RETURN,funarr ; degree
 END

