; Function to calculate Greenwich mean siderial time
; after formulas in Meeus (2002)  
FUNCTION GMST,jd,debug=debug


  IF KEYWORD_SET(debug) THEN BEGIN
   ljd=LONG(jd)
   fjd=jd-ljd
   IF fjd GE 0.5d THEN ut=fjd-0.5 $
   ELSE BEGIN
    ut=fjd+0.5
    ljd=ljd-1l
   ENDELSE
;   print,jd,ljd,fjd,ut
 
   T=(ljd+(0.5d)-2451545d)/36525d
   gmst1=(T*8640184d) MOD 86400d
   gmst1=gmst1+T*0.812866d
   gmst1=gmst1+T*((-6.2d-6)*T+0.093104d)*T ; sec
   gmst1=((gmst1+24110.54841d) MOD 86400d)+86400d
;   print,FIX(gmst1/3600d),FIX(gmst1/60d) MOD 60,gmst1 MOD 60d
   gmst1=((gmst1+ut*86400d*1.00273790935d) MOD 86400d)
;   print,FIX(gmst1/3600d),FIX(gmst1/60d) MOD 60,gmst1 MOD 60d
  
   theta1=(gmst1/864d*3.6d) MOD 360d
  ENDIF

   T0=(jd-2451545d)
   T=T0/36525d
   theta2=((36000d*T) MOD 360d)+0.770053608d*T
   theta2=theta2+100.46061837d
   theta2=theta2+T*(-T/(3.871d7)+(3.87933d-4))*T+360d
 
   theta0=(T0*360d) 
   theta0=theta0+T0*0.98564736629d
   theta0=theta0+T*(-T/(3.871d7)+(3.87933d-4))*T 
   theta0=(theta0+280.46061837d) MOD 360d
   index=WHERE(theta0 LT 0d)
   IF index(0) NE -1 THEN theta0(index)=theta0(index)+360d
   
; print,T,(jd-2451545d)/36525d,theta0,theta1,theta2,f='(g20.15)'
 
 RETURN,theta0
 END


